// ---------------------------------------------------------------------------
// 
//   Lily Engine alpha
// 
//   Copyright (c) 2010 Clifford Jolly
//     http://cliffjolly.com
//     cliff@cliffjolly.com
// 
// ---------------------------------------------------------------------------
// 
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//  
//   This program is distributed in the hope that it will be useful, but
//   WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//   General Public License for more details.
// 
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
//   USA
// -------------------------- END HEADER -------------------------------------

#ifndef WIDGETTRANSFORM_H
#define WIDGETTRANSFORM_H

#include "widgetsingleparent.h"

/// Arbitrary transformation Widget. Neat, but limited usefulness
/// unless doing some crazy 3D UI.
LUA_WRAP class WidgetTransform : public WidgetSingleParent {
	public:
	
		// Constructors/destructor
		WidgetTransform(void);
		WidgetTransform(TiXmlElement *xml);
		virtual ~WidgetTransform(void);
		
		// Inherited stuff
		void draw(void);
		bool handleEvent(const WidgetEvent *event);
			
		// TODO: Give it accessors.
		// TODO: Make this private.
		// TODO: Replace this with a Matrix4x4.
		double transform[16];
		
};

#endif
