// ---------------------------------------------------------------------------
// 
//   Lily Engine alpha
// 
//   Copyright (c) 2010 Clifford Jolly
//     http://cliffjolly.com
//     cliff@cliffjolly.com
// 
// ---------------------------------------------------------------------------
// 
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//  
//   This program is distributed in the hope that it will be useful, but
//   WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//   General Public License for more details.
// 
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
//   USA
// -------------------------- END HEADER -------------------------------------

#ifndef AUTOGEN_H
#define AUTOGEN_H

// Used as a marker for the wrapper generation system.
#define LUA_WRAP

class Widget;
struct lua_State;

// Defined in widget.cpp
Widget *getWidgetByUID(const std::string &uid);
void autoGenLuaWrapper_Widget_luaError(lua_State *L, const std::string &error);
void autoGenLuaWrapper_Widget_init(lua_State *L);
Widget *autoGenLuaWrapper_getWidgetFromTable(lua_State *L, int index);
void autoGenLuaWrapper_getTableFromWidget(lua_State *L, Widget *p);
void autoGenLuaWrapper_Widget_safeDelete(Widget *p);

#endif

